unit adxRTDTest_IMPL;

interface

uses
  Windows, SysUtils, Classes, ComServ, adxRTDTest_TLB, adxRTDServ, StdVcl;

type
  TADX_RTDTest = class(TadxRTDServer, IADX_RTDTest);

  TRTDServerModule = class(TadxXLRTDServerModule)
    procedure adxXlRTDServerModuleRTDInitialize(Sender: TObject);
    procedure adxXlRTDServerModuleConnectData(const Topics: array of String);
    procedure CommonTopicConnect(Sender: TObject);
    function CommonTopicRefreshData(Sender: TObject): OleVariant;
    procedure CommonTopicDisconnect(Sender: TObject);
    procedure adxXlRTDServerModuleRTDFinalize(Sender: TObject);
  private
  protected
  public
  end;

implementation

{$R *.dfm}

procedure TRTDServerModule.adxXlRTDServerModuleRTDInitialize(Sender: TObject);
begin
  Windows.OutputDebugString('OnRTDInitialize (MS SDK ServerStart)');
end;

procedure TRTDServerModule.adxXlRTDServerModuleConnectData(const Topics: array of string);
var
  i: Integer;
  Topic: TadxRTDTopic;
begin
  Windows.OutputDebugString('Module.OnConnectData (MS SDK ConnectData)');
  //
  // create the TadxRTDTopic instance on-demand
  // support _all_ parameters entered by the end-user "on the fly"
  //
  Topic := TadxRTDTopic.Create(Self);
  for i := Low(Topics) to High(Topics) do
    Topic.Strings[i] := Topics[i];
  Topic.OnConnect := CommonTopicConnect;
  Topic.OnRefreshData := CommonTopicRefreshData;
  Topic.OnDisconnect := CommonTopicDisconnect;
end;

procedure TRTDServerModule.CommonTopicConnect(Sender: TObject);
begin
  Windows.OutputDebugString('Topic.OnConnect (MS SDK ConnectData)');
end;

function TRTDServerModule.CommonTopicRefreshData(Sender: TObject): OleVariant;
begin
  Windows.OutputDebugString('Topic.OnRefreshData (MS SDK RefreshData)');
  Result := Random(100);
end;

procedure TRTDServerModule.CommonTopicDisconnect(Sender: TObject);
begin
  Windows.OutputDebugString('Topic.OnDisconnect (MS SDK DisconnectData)');
end;

procedure TRTDServerModule.adxXlRTDServerModuleRTDFinalize(Sender: TObject);
begin
  Windows.OutputDebugString('OnRTDFinalize (MS SDK ServerTerminate)');
end;

initialization
  TadxRTDFactory.Create(ComServer, TADX_RTDTest, CLASS_ADX_RTDTest, TRTDServerModule);

end.
